# -*- coding: latin-1 -*-
#########################################################
#Author: Jean-Baptiste Fasquel, LISA Laboratory, Angers University, France
#Copyright (C) 2013 Jean-Baptiste Fasquel
#########################################################


import numpy as np
import scipy as sp ; from scipy import misc
import skimage as sk; from skimage import exposure,filters
import matplotlib.pyplot as plt

###################
#Load image
###################
image=sp.misc.imread("td1_image_non_equalized_small.jpeg") 

###################
#Compute histogram of initial image
###################
histo,bins=sk.exposure.histogram(image)


###################
#BEGIN TODO: calcul manuel de la "cumulative distribution function"
#(commenter la fonction automatique: cdf,bins=sk.exposure.cumulative_distribution(image)
###################
fc,bins=sk.exposure.cumulative_distribution(image) #retourne dans l'intervalle [min,max], et normalisation max(cdf)==1
###################
#END TODO: calcul manuel de la "cumulative distribution function"
#(commenter la fonction automatique: cdf,bins=sk.exposure.cumulative_distribution(image)
###################

###################
#Conversion de l'image: on applique la fonction cumulative
###################
result=fc[image-np.min(image)] #rsultat entre [0,1] en float , en translatant les valeurs de l'image [min,max] -> [0,max-min]
result=np.round(result*255).astype(np.uint8) #rsultat entre [0,255]
sp.misc.imsave("image_non_equalized_result.jpg",result)

###################
#Compute histogram of result image
###################
bins_result=np.arange(np.min(result),np.max(result)+1)
histo_result=np.zeros((len(bins_result)))

#histo_result,bins_result=sk.exposure.histogram(result) #nbins=256
cdf_result,bins_result=sk.exposure.cumulative_distribution(result)

###################
#PLOT
###################
plt.subplot(221)
plt.title("Initial image")
plt.imshow(image,"gray")
plt.axis('off')
plt.subplot(222)
plt.title("Enhanced image")
plt.imshow(result,"gray")
plt.axis('off')
plt.subplot(223)
plt.title("Initial image\nHistogram and CDF")
plt.plot(bins,histo)
plt.plot(bins,fc*np.max(histo))
plt.subplot(224)
plt.title("Enhanced image\nHistogram and CDF")
plt.plot(bins_result,histo_result)
plt.plot(bins_result,cdf_result*np.max(histo_result))
plt.show()
